#version 330 core
// based on http://www.opengl-tutorial.org, WTFPL

uniform vec3 lightPos;

in vec3 normal;

in vec3 pos_ws;
in vec3 normal_cs;
in vec3 lightdir_cs;
in vec3 eyedir_cs;

out vec4 FragColor;

void main()
{
    vec3 lightColour = vec3( 1.0, 1.0, 1.0 );
    vec3 objColour = vec3(1.0f, 0.6f, 0.2f);
    float lightPower = 50.0;

    // material colours
    vec3 matDiff = vec3(1.0, 0.6, 0.2 );
    vec3 matAmb = vec3(0.1) * matDiff;
    vec3 matSpec = vec3(0.3);

    vec3 n = normalize( normal_cs );
    vec3 l = normalize( lightdir_cs );
    float distance = length( lightPos - pos_ws );

    vec3 e = normalize( eyedir_cs );
    vec3 r = reflect( -l, n );
    float cosAlpha = clamp( dot(e, r), 0, 1);

    float cosTheta = clamp( dot( n, l ), 0, 1 );
//    vec3 colour = 
//       ( matAmb ) +
//       ( matDiff * lightColour * lightPower * cosTheta / ( distance*distance ) ) + 
//       ( matSpec * lightColour * lightPower * pow( cosAlpha, 5 ) / (distance*distance) );

    FragColor = vec4(normal, 1);
} 
