#version 330 core
// based on http://www.opengl-tutorial.org, WTFPL

layout (location = 0) in vec3 aPos;
layout (location = 1) in vec3 aNormal;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform vec3 lightPos;

out vec3 normal;

out vec3 pos_ws;
out vec3 normal_cs;
out vec3 lightdir_cs;
out vec3 eyedir_cs;

void main()
{
    gl_Position = projection * view * model * vec4(aPos, 1.0);
    normal = aNormal;

    // world space
    pos_ws = ( model * vec4( aPos, 1 ) ).xyz;
    
    // camera space
    vec3 pos_cs = ( view * model * vec4(aPos, 1) ).xyz;
    eyedir_cs = vec3(0, 0, 0) - pos_cs;

    vec3 light_cs = ( view * vec4( lightPos, 1) ).xyz;
    lightdir_cs = light_cs + eyedir_cs;
    normal_cs = ( view * model * vec4( aNormal, 0 ) ).xyz;
}
